package cn.com.qmth.examcloud.task.api.provider;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.commons.base.util.JsonUtil;
import cn.com.qmth.examcloud.commons.web.support.ControllerSupport;
import cn.com.qmth.examcloud.task.api.DataSyncCloudService;
import cn.com.qmth.examcloud.task.api.request.SyncCourseReq;
import cn.com.qmth.examcloud.task.api.request.SyncExamReq;
import cn.com.qmth.examcloud.task.api.request.SyncOrgReq;
import cn.com.qmth.examcloud.task.api.request.SyncSpecialtyReq;
import cn.com.qmth.examcloud.task.api.request.SyncStudentReq;
import cn.com.qmth.examcloud.task.api.response.SyncCourseResp;
import cn.com.qmth.examcloud.task.api.response.SyncExamResp;
import cn.com.qmth.examcloud.task.api.response.SyncOrgResp;
import cn.com.qmth.examcloud.task.api.response.SyncSpecialtyResp;
import cn.com.qmth.examcloud.task.api.response.SyncStudentResp;
import cn.com.qmth.examcloud.task.dao.DataSyncRepo;
import cn.com.qmth.examcloud.task.dao.entity.DataSyncEntity;
import cn.com.qmth.examcloud.task.service.DataSyncService;
import cn.com.qmth.examcloud.task.service.bean.CourseInfo;
import cn.com.qmth.examcloud.task.service.bean.OrgInfo;
import cn.com.qmth.examcloud.task.service.bean.SpecialtyInfo;
import cn.com.qmth.examcloud.task.service.bean.StudentInfo;

/**
 * 数据同步
 *
 * @author WANGWEI
 * @date 2018年8月2日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@RestController
@RequestMapping("${$rmp.cloud.task}" + "dataSync")
public class DataSyncCloudServiceProvider extends ControllerSupport
		implements
			DataSyncCloudService {

	@Autowired
	DataSyncService dataSyncService;

	@Autowired
	DataSyncRepo dataSyncRepo;

	private static final long serialVersionUID = -2880611326177571371L;

	@PostMapping("syncCourse")
	@Override
	public SyncCourseResp syncCourse(@RequestBody SyncCourseReq req) {
		CourseInfo info = new CourseInfo();

		DataSyncEntity entity = new DataSyncEntity();
		entity.setMethodName("syncCourse");
		entity.setParamType(CourseInfo.class.getName());
		entity.setParam(JsonUtil.toJson(info));

		dataSyncRepo.saveAndFlush(entity);

		dataSyncService.syncCourse(info);
		return null;
	}

	@PostMapping("syncOrg")
	@Override
	public SyncOrgResp syncOrg(@RequestBody SyncOrgReq req) {
		OrgInfo info = new OrgInfo();

		DataSyncEntity entity = new DataSyncEntity();
		entity.setMethodName("syncOrg");
		entity.setParamType(CourseInfo.class.getName());
		entity.setParam(JsonUtil.toJson(info));

		dataSyncRepo.saveAndFlush(entity);

		dataSyncService.syncOrg(info);
		return null;
	}

	@PostMapping("syncStudent")
	@Override
	public SyncStudentResp syncStudent(@RequestBody SyncStudentReq req) {
		StudentInfo info = new StudentInfo();

		DataSyncEntity entity = new DataSyncEntity();
		entity.setMethodName("syncStudent");
		entity.setParamType(CourseInfo.class.getName());
		entity.setParam(JsonUtil.toJson(info));

		dataSyncRepo.saveAndFlush(entity);

		dataSyncService.syncStudent(info);
		return null;
	}

	@PostMapping("syncSpecialty")
	@Override
	public SyncSpecialtyResp syncSpecialty(@RequestBody SyncSpecialtyReq req) {
		SpecialtyInfo info = new SpecialtyInfo();

		DataSyncEntity entity = new DataSyncEntity();
		entity.setMethodName("syncSpecialty");
		entity.setParamType(CourseInfo.class.getName());
		entity.setParam(JsonUtil.toJson(info));

		dataSyncRepo.saveAndFlush(entity);

		dataSyncService.syncSpecialty(info);
		return null;
	}

	@PostMapping("syncExam")
	@Override
	public SyncExamResp syncExam(@RequestBody SyncExamReq req) {
		return null;
	}

}
